searchNodes=[{"doc":"Generates native boilerplate code for all the .spec.exs files found in c_src dir","ref":"Mix.Tasks.Compile.Unifex.html","title":"Mix.Tasks.Compile.Unifex","type":"task"},{"doc":"This module provides different generators allowing to map the types from Unifex specs into proper native typesThe generators from this module are trying to delegate the calls to the callbacks in modules adequate for the type but provide fallback values (all the callbacks are optional)","ref":"Unifex.BaseType.html","title":"Unifex.BaseType","type":"behaviour"},{"doc":"","ref":"Unifex.BaseType.html#generate_arg_name/1","title":"Unifex.BaseType.generate_arg_name/1","type":"function"},{"doc":"Generates parsing of UNIFEX_TERM argument into the native variable","ref":"Unifex.BaseType.html#generate_arg_parse/2","title":"Unifex.BaseType.generate_arg_parse/2","type":"function"},{"doc":"Generates function call parsing UNIFEX_TERM argument into the native variable with name variable. Function should return boolean value.","ref":"Unifex.BaseType.html#c:generate_arg_parse/2","title":"Unifex.BaseType.generate_arg_parse/2","type":"callback"},{"doc":"Provides a way to convert native variable name into UNIFEX_TERMTries to get value from type-specific module, uses enif_make_\#{type} as fallback value.","ref":"Unifex.BaseType.html#generate_arg_serialize/1","title":"Unifex.BaseType.generate_arg_serialize/1","type":"function"},{"doc":"Provides a way to convert native variable name into UNIFEX_TERM","ref":"Unifex.BaseType.html#c:generate_arg_serialize/1","title":"Unifex.BaseType.generate_arg_serialize/1","type":"callback"},{"doc":"Generates a declaration of parameter (to be placed in function header) based on generate_native_type/0 and provided name.Uses type as fallback for c:generate_native_type/1","ref":"Unifex.BaseType.html#generate_declaration/1","title":"Unifex.BaseType.generate_declaration/1","type":"function"},{"doc":"Generates an destrucition of variable content. Should be paired with generate_initialization/1Returns an empty string if the type does not provide destructor","ref":"Unifex.BaseType.html#generate_destruction/1","title":"Unifex.BaseType.generate_destruction/1","type":"function"},{"doc":"Generates a destruction of variable content. Should be paired with generate_initialization/1","ref":"Unifex.BaseType.html#c:generate_destruction/1","title":"Unifex.BaseType.generate_destruction/1","type":"callback"},{"doc":"Generates Elixir post-processing of the value returned from native function.Fallbacks to simply passing the value (as variable reference)","ref":"Unifex.BaseType.html#generate_elixir_postprocessing/1","title":"Unifex.BaseType.generate_elixir_postprocessing/1","type":"function"},{"doc":"Generates Elixir post-processing of the value returned from native function.Should return quoted code. The value can be referenced using Macro.var/2 call. Useful when some call cannot be made from native code (e.g. call to another NIF from NIF)","ref":"Unifex.BaseType.html#c:generate_elixir_postprocessing/1","title":"Unifex.BaseType.generate_elixir_postprocessing/1","type":"callback"},{"doc":"Generates an initialization of variable content. Should be paired with generate_destruction/1Returns an empty string if the type does not provide initialization","ref":"Unifex.BaseType.html#generate_initialization/1","title":"Unifex.BaseType.generate_initialization/1","type":"function"},{"doc":"Generates an initialization of variable content. Should be paired with generate_destruction/1","ref":"Unifex.BaseType.html#c:generate_initialization/1","title":"Unifex.BaseType.generate_initialization/1","type":"callback"},{"doc":"Generates a native counterpart for the type.","ref":"Unifex.BaseType.html#c:generate_native_type/0","title":"Unifex.BaseType.generate_native_type/0","type":"callback"},{"doc":"Generates an expression that will return how many bytes should be allocated for this type.","ref":"Unifex.BaseType.html#c:generate_sizeof/0","title":"Unifex.BaseType.generate_sizeof/0","type":"callback"},{"doc":"","ref":"Unifex.BaseType.html#t:arg_parse_ctx_t/0","title":"Unifex.BaseType.arg_parse_ctx_t/0","type":"type"},{"doc":"","ref":"Unifex.BaseType.html#t:spec_tuple_t/0","title":"Unifex.BaseType.spec_tuple_t/0","type":"type"},{"doc":"","ref":"Unifex.BaseType.html#t:t/0","title":"Unifex.BaseType.t/0","type":"type"},{"doc":"Module implementing Unifex.BaseType behaviour for atoms.Atoms in native code are represented by C-strings (char *)","ref":"Unifex.BaseType.Atom.html","title":"Unifex.BaseType.Atom","type":"module"},{"doc":"Module implementing Unifex.BaseType behaviour for boolean atoms.Booleans in native code are converted to int with value either 0 or 1.","ref":"Unifex.BaseType.Bool.html","title":"Unifex.BaseType.Bool","type":"module"},{"doc":"Module implementing Unifex.BaseType behaviour for 64-bit integer.Maps int64 Unifex type to an int64_t native type.","ref":"Unifex.BaseType.Int64.html","title":"Unifex.BaseType.Int64","type":"module"},{"doc":"Module implementing Unifex.BaseType behaviour for payloads.","ref":"Unifex.BaseType.Payload.html","title":"Unifex.BaseType.Payload","type":"module"},{"doc":"Module implementing Unifex.BaseType behaviour for Erlang PIDs","ref":"Unifex.BaseType.Pid.html","title":"Unifex.BaseType.Pid","type":"module"},{"doc":"Module implementing Unifex.BaseType behaviour for Unifex state.","ref":"Unifex.BaseType.State.html","title":"Unifex.BaseType.State","type":"module"},{"doc":"Module implementing Unifex.BaseType behaviour for Unifex state.","ref":"Unifex.BaseType.String.html","title":"Unifex.BaseType.String","type":"module"},{"doc":"Module implementing Unifex.BaseType behaviour for 64-bit unsigned integer.Maps uint64 Unifex type to a uint64_t native type.","ref":"Unifex.BaseType.Uint64.html","title":"Unifex.BaseType.Uint64","type":"module"},{"doc":"Module implementing Unifex.BaseType behaviour for unsigned int.","ref":"Unifex.BaseType.Unsigned.html","title":"Unifex.BaseType.Unsigned","type":"module"},{"doc":"This module allows to generate definitions for native functions described in Unifex specs.To acheive that simply use this module:use Unifex.Loader","ref":"Unifex.Loader.html","title":"Unifex.Loader","type":"module"},{"doc":"Module responsible for C code genearation based on Unifex specs","ref":"Unifex.NativeCodeGenerator.html","title":"Unifex.NativeCodeGenerator","type":"module"},{"doc":"Helper for generating code. Uses sigil_g/2 underneath.It supports all the flags supported by sigil_g/2 and the following ones:j(joiner) - joins list of strings using joinern - alias for j(\\n)If passed a list and flags supported by sigil_g/2, each flag will be executed on each element of the list, until the list is joined by using j or n flag.","ref":"Unifex.NativeCodeGenerator.html#gen/2","title":"Unifex.NativeCodeGenerator.gen/2","type":"function"},{"doc":"Generates C boilerplate for a native code based on a specTakes the name for the .c and .h files and the specs parsed by Unifex.SpecsParser.parse_specs()/1 and generates code of header and source code, returning them in a tuple of 2 strings.","ref":"Unifex.NativeCodeGenerator.html#generate_code/2","title":"Unifex.NativeCodeGenerator.generate_code/2","type":"function"},{"doc":"Sigil used for indentation of generated code.By itself it does nothing, but has very useful flags:r trims trailing whitespaces of each line and removes subsequent empty linest trims the stringi indents all but the first line. Helpful when used inside string interpolation that already has been indentedI indents every line of string","ref":"Unifex.NativeCodeGenerator.html#sigil_g/2","title":"Unifex.NativeCodeGenerator.sigil_g/2","type":"function"},{"doc":"","ref":"Unifex.NativeCodeGenerator.html#t:code_t/0","title":"Unifex.NativeCodeGenerator.code_t/0","type":"type"},{"doc":"","ref":"Unifex.PostprocessingAstGenerator.html","title":"Unifex.PostprocessingAstGenerator","type":"module"},{"doc":"","ref":"Unifex.PostprocessingAstGenerator.html#generate_postprocessing_clauses/1","title":"Unifex.PostprocessingAstGenerator.generate_postprocessing_clauses/1","type":"function"},{"doc":"Module exporting macros that can be used to define Unifex specs.Example of such specs is provided below:module Membrane.Element.Mad.Decoder.Native spec create() :: {:ok :: label, state} spec decode_frame(payload, offset :: int, state) :: {:ok :: label, {payload, bytes_used :: long, sample_rate :: long, channels :: int}} | {:error :: label, :buflen :: label} | {:error :: label, :malformed :: label} | {:error :: label, {:recoverable :: label, bytes_to_skip :: int}} dirty :cpu, decode_frame: 3 sends {:example_msg :: label, number :: int}According to this specification, module Membrane.Element.Mad.Decoder.Native should contain 2 functions: create/0 and decode_frame/3 (which is a cpu-bound dirty NIF). The module should use Unifex.Loader to provide access to these functions. What is more, messages of the form {:example_msg, integer} can be sent from the native code to erlang processes.The generated boilerplate would require implementation of the following functions:UNIFEX_TERM create(UnifexEnv* env); UNIFEX_TERM decode_frame(UnifexEnv* env, UnifexPayload * payload, int offset, State* state);Also the following functions that should be called to return results will be generated:UNIFEX_TERM create_result_ok(UnifexEnv* env, State* state); UNIFEX_TERM decode_frame_result_ok(UnifexEnv* env, UnifexPayload * payload, long bytes_used, long sample_rate, int channels); UNIFEX_TERM decode_frame_result_error_buflen(UnifexEnv* env); UNIFEX_TERM decode_frame_result_error_malformed(UnifexEnv* env); UNIFEX_TERM decode_frame_result_error_recoverable(UnifexEnv* env, int bytes_to_skip);See docs for appropriate macros for more details.","ref":"Unifex.Specs.html","title":"Unifex.Specs","type":"module"},{"doc":"Defines names of callbacks invoked on specified hook.The available hooks are::load - invoked when the library is loaded. Callback must have the following typing:int on_load(UnifexEnv *env, void ** priv_data)The callback receives an env and a pointer to private data that is initialized with NULL and can be set to whatever should be passed to other callbacks. If callback returns anything else than 0, the library fails to load.:upgrade - called when the library is loaded while there is old code for this module with a native library loaded. Compared to :load, it also receives old_priv_data:int on_upgrade(UnifexEnv* env, void** priv_data, void** old_priv_data)Both old and new private data can be modified If this callback is not defined, the module code cannot be hot-swapped. Non-zero return value also prevents code upgrade.:unload - called when the code for module is unloaded. It has the following declaration:void on_unload(UnifexEnv *env, void * priv_data)","ref":"Unifex.Specs.html#callback/2","title":"Unifex.Specs.callback/2","type":"macro"},{"doc":"Macro used for marking functions as dirty, i.e. performing long cpu-bound or io-bound operations.The macro should be used the following way:dirty type, function1: function1_arity, ...when type is one of::cpu - marks function as CPU-bound (maps to the ERL_NIF_DIRTY_JOB_CPU_BOUND erlang flag):io - marks function as IO-bound (maps to the ERL_NIF_DIRTY_JOB_IO_BOUND erlang flag)","ref":"Unifex.Specs.html#dirty/2","title":"Unifex.Specs.dirty/2","type":"macro"},{"doc":"Defines module that exports native functions to Elixir world.The module needs to be defined manually, but it can use Unifex.Loader to have functions declared with spec/1 automatically defined.","ref":"Unifex.Specs.html#module/1","title":"Unifex.Specs.module/1","type":"macro"},{"doc":"Defines terms that can be sent from the native code to elixir processes.Creates native function that can be invoked to send specified data. Name of the function starts with send_ and is constructed from labels.","ref":"Unifex.Specs.html#sends/1","title":"Unifex.Specs.sends/1","type":"macro"},{"doc":"Defines native function specification.The specification should be in the form ofspec function_name(parameter1 :: parameter1_type, some_type, parameter3 :: parameter3_type, ...) :: {:label1 :: label, {result_value1 :: result_value1_type, some_type2, ...}} | {:label2 :: label, other_result_value2 :: other_result_value2_type}ParametersSpecs for parameters can either take the form of parameter1 :: parameter1_type which will generate parameter with name parameter1 of type parameter1_type The other form - just a name, like some_type - will generate parameter some_type of type some_type.Custom types can be added by creating modules Unifex.BaseType.Type that implement Unifex.BaseType behaviour. Then, they can by used in specs as type.Each generated function gets additional UnifexEnv* env as the first parameter implicitly.Returned valuesSpecs for returned values contain a special type - label. An atom of type label will be put literally in returned values by the special function generated for each spec. Names of the generated functions start with Elixir function name (e.g. create) followed by _result_ part and then all the labels joined with _.ExampleThe example is provided in the moduledoc of this module.","ref":"Unifex.Specs.html#spec/1","title":"Unifex.Specs.spec/1","type":"macro"},{"doc":"Module that handles parsing Unifex specs for native boilerplate code generation.For information on how to create such specs, see Unifex.Specs module.","ref":"Unifex.SpecsParser.html","title":"Unifex.SpecsParser","type":"module"},{"doc":"Parses Unifex specs of native functions.","ref":"Unifex.SpecsParser.html#parse_specs/1","title":"Unifex.SpecsParser.parse_specs/1","type":"function"},{"doc":"","ref":"Unifex.SpecsParser.html#t:parsed_specs_t/0","title":"Unifex.SpecsParser.parsed_specs_t/0","type":"type"},{"doc":"Unifex Unifex is a tool for generating interfaces between native C code and Elixir, that:provides intuitive and conscise tools for defining native interfaces,generates all the boilerplate for you,provides useful abstractions over binaries and state,makes native code independent from erl_nif library, so once port-based interface is supported, the same code will be usable either with NIFs or ports.API documentation is available at HexDocs.","ref":"readme.html","title":"Unifex","type":"extras"},{"doc":"To install, you need to configure Mix project as follows:defmodule MyApp.Mixfile do use Mix.Project def project do [ app: :my_app, compilers: [:unifex, :bundlex] ++ Mix.compilers, # add unifex and bundlex to compilers ..., deps: deps() ] end defp deps() do [ {:unifex, &quot;~&gt; 0.2.0&quot;} # add unifex to deps ] end end","ref":"readme.html#instalation","title":"Unifex - Instalation","type":"extras"},{"doc":"For detailed usage description see Creating Unifex NIF guide.","ref":"readme.html#usage","title":"Unifex - Usage","type":"extras"},{"doc":"Unifex depends on the following libraries:BundlexShmex","ref":"readme.html#see-also","title":"Unifex - See also","type":"extras"},{"doc":"Copyright 2018, Software MansionLicensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Unifex - Copyright and License","type":"extras"},{"doc":"Creating Unifex Nif","ref":"creating_unifex_nif.html","title":"Creating Unifex Nif","type":"extras"},{"doc":"In order to start working on NIF, you need to prepare a few things:Add Unifex to deps in mix.exs: defp deps do [ {:unifex, &quot;~&gt; 0.1&quot;} ] endAnd compilers to the project definition: def project do [ compilers: [:unifex, :bundlex] ++ Mix.compilers(), (..) ] endUnifex uses Bundlex to compile the native code. To make it work, create the bundlex.exs file in the project's root directory with the following content: defmodule Example.BundlexProject do use Bundlex.Project def project() do [ nifs: nifs(Bundlex.platform()) ] end def nifs(_platform) do [ example: [ deps: [unifex: :unifex], src_base: &quot;example&quot;, sources: [&quot;_generated/example.c&quot;, &quot;example.c&quot;] ] ] end endThis defines a nif called example that will be implemented in two .c files. Bundlex expects these files to be located in c_src/example directory. More details on how to use it can be found in its documentation.","ref":"creating_unifex_nif.html#preparation","title":"Creating Unifex Nif - Preparation","type":"extras"},{"doc":"Let's start by creating a c_src/example directory and the files that will be needed:mkdir -p c_src/example cd c_src/example touch example.c touch example.h touch example.spec.exsYou may wonder where is the _generated/example.c. Well, as the name suggests, it will be generated based on example.spec.exs!Here are the contents of example.spec.exs:module Example.Native callback :load spec init() :: {:ok :: label, state} spec foo(target :: pid, state) :: {:ok :: label, answer :: int} | {:error :: label, reason :: atom} sends {:example_msg :: label, num :: int}This will result in generating the following header:#pragma once #include &lt;stdio.h&gt; #include &lt;erl_nif.h&gt; #include &lt;unifex/unifex.h&gt; #include &lt;unifex/payload.h&gt; #include &quot;../example.h&quot; /* * Declaration of native functions for module Elixir.Example.Native. * The implementation have to be provided by the user. */ UNIFEX_TERM init(UnifexEnv* env); UNIFEX_TERM foo(UnifexEnv* env, UnifexPid target, UnifexNifState* state); /* * Functions that manage lib and state lifecycle * Functions with 'unifex_' prefix are generated automatically, * the user have to implement rest of them. */ #define UNIFEX_MODULE &quot;Elixir.Example.Native&quot; /** * Allocates the state struct. Have to be paired with 'unifex_release_state' call */ UnifexNifState* unifex_alloc_state(UnifexEnv* env); /** * Releases state stuct allocated via 'unifex_alloc_state'. * State struct should be considered invalid after this call. */ void unifex_release_state(UnifexEnv* env, UnifexNifState* state); /** * Callback called when the state struct is destroyed. It should * be responsible for releasing any resources kept inside state. */ void handle_destroy_state(UnifexEnv* env, UnifexNifState* state); /* * Callbacks for nif lifecycle hooks. * Have to be implemented by user. */ int handle_load(UnifexEnv * env, void ** priv_data); /* * Functions that create the defined output from Nif. * They are automatically generated and don't need to be implemented. */ UNIFEX_TERM init_result_ok(UnifexEnv* env, UnifexNifState* state); UNIFEX_TERM foo_result_ok(UnifexEnv* env, int answer); UNIFEX_TERM foo_result_error(UnifexEnv* env, char* reason); /* * Functions that send the defined messages from Nif. * They are automatically generated and don't need to be implemented. */ int send_example_msg(UnifexEnv* env, UnifexPid pid, int flags, int num);More information on how .spec.exs files should be created can be found in docs for Unifex.Specs module.Along with the header, _generated/example.c file will be created, providing definitions for some of the functions you see in the header.Next step is to create struct that will be used as state for created nif and include generated header inside example.h. Since there is no name collision, typdef can be used to create an alias for UnifexNifState and refer to it as State.#pragma once typedef struct MyState UnifexNifState; struct MyState { int a; }; typedef UnifexNifState State; #include &quot;_generated/example.h&quot;Finally, let's provide required implementations in example.c:#include &quot;example.h&quot; int handle_load(UnifexEnv * env, void ** priv_data) { UNIFEX_UNUSED(env); UNIFEX_UNUSED(priv_data); printf(&quot;Hello from the native side!\\r\\n&quot;); return 0; } UNIFEX_TERM init(UnifexEnv* env) { State * state = unifex_alloc_state(env); state-&gt;a = 42; UNIFEX_TERM res = init_result_ok(env, state); unifex_release_state(env, state); return res; } UNIFEX_TERM foo(UnifexEnv* env, UnifexPid pid, State* state) { int res = send_example_msg(env, pid, 0, state-&gt;a); if (!res) { return foo_result_error(env, &quot;send_failed&quot;); } return foo_result_ok(env, state-&gt;a); } void handle_destroy_state(UnifexEnv* env, State* state) { UNIFEX_UNUSED(env); state-&gt;a = 0; }Now the project should sucessfully compile. Run mix deps.get &amp;&amp; mix compile to make sure everything is fine.","ref":"creating_unifex_nif.html#native-code","title":"Creating Unifex Nif - Native code","type":"extras"},{"doc":"All you have to do in order to access natively implemented functions is to create a module with the name as defined in example.spec.exs and to use Unifex.Loader there:defmodule Example.Native do use Unifex.Loader endAnd that's it! You can now run iex -S mix and check it out yourself:iex(1)&gt; alias Example.Native iex(2)&gt; {:ok, state} = Native.init() Hello from the native side! {:ok, #Reference&lt;0.3961161465.633208834.69562&gt;} iex(3)&gt; Native.foo(self(), state) {:ok, 42} iex(4)&gt; flush() {:example_msg, 42} :ok","ref":"creating_unifex_nif.html#elixir-module","title":"Creating Unifex Nif - Elixir module","type":"extras"}]